| OpenCV 4.3.0 Open Source Computer Vision

Public Types | Public Member Functions | Static Public Member Functions | List of all members
cv::xfeatures2d::VGG Class Referenceabstract
Extra 2D Features Framework » Experimental 2D Features Algorithms

Class implementing VGG (Oxford Visual Geometry Group) descriptor trained end to end using "Descriptor Learning Using Convex Optimisation" (DLCO) aparatus described in [213]. More...

`#include <opencv2/xfeatures2d.hpp>`

Inheritance diagram for cv::xfeatures2d::VGG:

## Public Types
enum | { VGG_120 = 100, VGG_80 = 101, VGG_64 = 102, VGG_48 = 103 }

## Public Member Functions
virtual float | getScaleFactor () const =0
virtual float | getSigma () const =0
virtual bool | getUseNormalizeDescriptor () const =0
virtual bool | getUseNormalizeImage () const =0
virtual bool | getUseScaleOrientation () const =0
virtual void | setScaleFactor (const float scale_factor)=0
virtual void | setSigma (const float isigma)=0
virtual void | setUseNormalizeDescriptor (const bool dsc_normalize)=0
virtual void | setUseNormalizeImage (const bool img_normalize)=0
virtual void | setUseScaleOrientation (const bool use_scale_orientation)=0
Public Member Functions inherited from cv::Feature2D
virtual | ~Feature2D ()
virtual void | compute (InputArray image, std::vector< KeyPoint > &keypoints, OutputArray descriptors)
| Computes the descriptors for a set of keypoints detected in an image (first variant) or image set (second variant). More...
virtual void | compute (InputArrayOfArrays images, std::vector< std::vector< KeyPoint > > &keypoints, OutputArrayOfArrays descriptors)
virtual int | defaultNorm () const
virtual int | descriptorSize () const
virtual int | descriptorType () const
virtual void | detect (InputArray image, std::vector< KeyPoint > &keypoints, InputArray mask=noArray())
| Detects keypoints in an image (first variant) or image set (second variant). More...
virtual void | detect (InputArrayOfArrays images, std::vector< std::vector< KeyPoint > > &keypoints, InputArrayOfArrays masks=noArray())
virtual void | detectAndCompute (InputArray image, InputArray mask, std::vector< KeyPoint > &keypoints, OutputArray descriptors, bool useProvidedKeypoints=false)
virtual bool | empty () const CV_OVERRIDE
| Return true if detector object is empty. More...
virtual String | getDefaultName () const CV_OVERRIDE
void | read (const String &fileName)
virtual void | read (const FileNode &) CV_OVERRIDE
| Reads algorithm parameters from a file storage. More...
void | write (const String &fileName) const
virtual void | write (FileStorage &) const CV_OVERRIDE
| Stores algorithm parameters in a file storage. More...
void | write (const Ptr< FileStorage > &fs, const String &name=String()) const
Public Member Functions inherited from cv::Algorithm
| Algorithm ()
virtual | ~Algorithm ()
virtual void | clear ()
| Clears the algorithm state. More...
virtual void | save (const String &filename) const
void | write (const Ptr< FileStorage > &fs, const String &name=String()) const
| simplified API for language bindings This is an overloaded member function, provided for convenience. It differs from the above function only in what argument(s) it accepts. More...

## Static Public Member Functions
static Ptr< VGG > | create (int desc=VGG::VGG_120, float isigma=1.4f, bool img_normalize=true, bool use_scale_orientation=true, float scale_factor=6.25f, bool dsc_normalize=false)
Static Public Member Functions inherited from cv::Algorithm
template<typename _Tp >
static Ptr< _Tp > | load (const String &filename, const String &objname=String())
| Loads algorithm from the file. More...
template<typename _Tp >
static Ptr< _Tp > | loadFromString (const String &strModel, const String &objname=String())
| Loads algorithm from a String. More...
template<typename _Tp >
static Ptr< _Tp > | read (const FileNode &fn)
| Reads algorithm from the file node. More...

## Additional Inherited Members
Protected Member Functions inherited from cv::Algorithm
void | writeFormat (FileStorage &fs) const

## Detailed Description

Class implementing VGG (Oxford Visual Geometry Group) descriptor trained end to end using "Descriptor Learning Using Convex Optimisation" (DLCO) aparatus described in [213].

Parameters

  desc | type of descriptor to use, VGG::VGG_120 is default (120 dimensions float) Available types are VGG::VGG_120, VGG::VGG_80, VGG::VGG_64, VGG::VGG_48
  isigma | gaussian kernel value for image blur (default is 1.4f)
  img_normalize | use image sample intensity normalization (enabled by default)
  use_orientation | sample patterns using keypoints orientation, enabled by default
  scale_factor | adjust the sampling window of detected keypoints to 64.0f (VGG sampling window) 6.25f is default and fits for KAZE, SURF detected keypoints window ratio 6.75f should be the scale for SIFT detected keypoints window ratio 5.00f should be the scale for AKAZE, MSD, AGAST, FAST, BRISK keypoints window ratio 0.75f should be the scale for ORB keypoints ratio
  dsc_normalize | clamp descriptors to 255 and convert to uchar CV_8UC1 (disabled by default)

## Member Enumeration Documentation

## ◆ anonymous enum

anonymous enum

Enumerator
VGG_120 |
VGG_80 |
VGG_64 |
VGG_48 |

## Member Function Documentation

## ◆ create()

static Ptr<VGG> cv::xfeatures2d::VGG::create | ( | int | desc = `VGG::VGG_120`,
|  | float | isigma = `1.4f`,
|  | bool | img_normalize = `true`,
|  | bool | use_scale_orientation = `true`,
|  | float | scale_factor = `6.25f`,
|  | bool | dsc_normalize = `false`
| ) |  |
| static

Python:
| retval | = | cv.xfeatures2d.VGG_create( | [, desc[, isigma[, img_normalize[, use_scale_orientation[, scale_factor[, dsc_normalize]]]]]] | )

## ◆ getScaleFactor()

virtual float cv::xfeatures2d::VGG::getScaleFactor | ( |  | ) | const
| pure virtual

Python:
| retval | = | cv.xfeatures2d_VGG.getScaleFactor( |  | )

## ◆ getSigma()

virtual float cv::xfeatures2d::VGG::getSigma | ( |  | ) | const
| pure virtual

Python:
| retval | = | cv.xfeatures2d_VGG.getSigma( |  | )

## ◆ getUseNormalizeDescriptor()

virtual bool cv::xfeatures2d::VGG::getUseNormalizeDescriptor | ( |  | ) | const
| pure virtual

Python:
| retval | = | cv.xfeatures2d_VGG.getUseNormalizeDescriptor( |  | )

## ◆ getUseNormalizeImage()

virtual bool cv::xfeatures2d::VGG::getUseNormalizeImage | ( |  | ) | const
| pure virtual

Python:
| retval | = | cv.xfeatures2d_VGG.getUseNormalizeImage( |  | )

## ◆ getUseScaleOrientation()

virtual bool cv::xfeatures2d::VGG::getUseScaleOrientation | ( |  | ) | const
| pure virtual

Python:
| retval | = | cv.xfeatures2d_VGG.getUseScaleOrientation( |  | )

## ◆ setScaleFactor()

virtual void cv::xfeatures2d::VGG::setScaleFactor | ( | const float | scale_factor | ) |
| pure virtual

Python:
| None | = | cv.xfeatures2d_VGG.setScaleFactor( | scale_factor | )

## ◆ setSigma()

virtual void cv::xfeatures2d::VGG::setSigma | ( | const float | isigma | ) |
| pure virtual

Python:
| None | = | cv.xfeatures2d_VGG.setSigma( | isigma | )

## ◆ setUseNormalizeDescriptor()

virtual void cv::xfeatures2d::VGG::setUseNormalizeDescriptor | ( | const bool | dsc_normalize | ) |
| pure virtual

Python:
| None | = | cv.xfeatures2d_VGG.setUseNormalizeDescriptor( | dsc_normalize | )

## ◆ setUseNormalizeImage()

virtual void cv::xfeatures2d::VGG::setUseNormalizeImage | ( | const bool | img_normalize | ) |
| pure virtual

Python:
| None | = | cv.xfeatures2d_VGG.setUseNormalizeImage( | img_normalize | )

## ◆ setUseScaleOrientation()

virtual void cv::xfeatures2d::VGG::setUseScaleOrientation | ( | const bool | use_scale_orientation | ) |
| pure virtual

Python:
| None | = | cv.xfeatures2d_VGG.setUseScaleOrientation( | use_scale_orientation | )

The documentation for this class was generated from the following file:

- opencv2/xfeatures2d.hpp